clang 10.0.0git

Classes | Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | List of all members
clang::ObjCTypeParamList Class Referencefinal

Stores a list of Objective-C type parameters for a parameterized class or a category/extension thereof. More...

`#include "clang/AST/DeclObjC.h"`

Inheritance diagram for clang::ObjCTypeParamList:
[legend]
Collaboration diagram for clang::ObjCTypeParamList:
[legend]

## Public Types
using | iterator = ObjCTypeParamDecl **
| Iterate through the type parameters in the list. More...
using | const_iterator = ObjCTypeParamDecl *const *

## Public Member Functions
iterator | begin ()
iterator | end ()
unsigned | size () const
| Determine the number of type parameters in this list. More...
const_iterator | begin () const
const_iterator | end () const
ObjCTypeParamDecl * | front () const
ObjCTypeParamDecl * | back () const
SourceLocation | getLAngleLoc () const
SourceLocation | getRAngleLoc () const
SourceRange | getSourceRange () const
void | gatherDefaultTypeArgs (SmallVectorImpl< QualType > &typeArgs) const
| Gather the default set of type arguments to be substituted for these type parameters when dealing with an unspecialized type. More...

## Static Public Member Functions
static ObjCTypeParamList * | create (ASTContext &ctx, SourceLocation lAngleLoc, ArrayRef< ObjCTypeParamDecl *> typeParams, SourceLocation rAngleLoc)
| Create a new Objective-C type parameter list. More...

## Public Attributes
friend | TrailingObjects
PODSourceRange | Brackets
| Location of the left and right angle brackets. More...
ObjCTypeParamDecl * | AlignmentHack

## Detailed Description

Stores a list of Objective-C type parameters for a parameterized class or a category/extension thereof.

@interface NSArray<T> // stores the <T>
@end

Definition at line 649 of file DeclObjC.h.

## Member Typedef Documentation

## ◆ const_iterator

using clang::ObjCTypeParamList::const_iterator = ObjCTypeParamDecl * const *

Definition at line 692 of file DeclObjC.h.

## ◆ iterator

using clang::ObjCTypeParamList::iterator = ObjCTypeParamDecl **

Iterate through the type parameters in the list.

Definition at line 682 of file DeclObjC.h.

## Member Function Documentation

## ◆ back()

ObjCTypeParamDecl* clang::ObjCTypeParamList::back | ( |  | ) | const
| inline

Definition at line 707 of file DeclObjC.h.

References clang::ObjCListBase::size().

## ◆ begin() [1/2]

iterator clang::ObjCTypeParamList::begin | ( |  | ) |
| inline

Definition at line 684 of file DeclObjC.h.

Referenced by sameObjCTypeArgs().

## ◆ begin() [2/2]

const_iterator clang::ObjCTypeParamList::begin | ( |  | ) | const
| inline

Definition at line 694 of file DeclObjC.h.

## ◆ create()

ObjCTypeParamList * ObjCTypeParamList::create | ( | ASTContext & | ctx,
|  | SourceLocation | lAngleLoc,
|  | ArrayRef< ObjCTypeParamDecl *> | typeParams,
|  | SourceLocation | rAngleLoc
| ) |  |
| static

Create a new Objective-C type parameter list.

Definition at line 1459 of file DeclObjC.cpp.

References clang::ASTContext::Allocate().

Referenced by clang::ASTNodeImporter::ImportObjCTypeParamList(), and clang::ASTDeclReader::ReadObjCTypeParamList().

## ◆ end() [1/2]

iterator clang::ObjCTypeParamList::end | ( |  | ) |
| inline

Definition at line 686 of file DeclObjC.h.

References clang::ObjCListBase::size().

## ◆ end() [2/2]

const_iterator clang::ObjCTypeParamList::end | ( |  | ) | const
| inline

Definition at line 698 of file DeclObjC.h.

References clang::ObjCListBase::size().

## ◆ front()

ObjCTypeParamDecl* clang::ObjCTypeParamList::front | ( |  | ) | const
| inline

Definition at line 702 of file DeclObjC.h.

References clang::ObjCListBase::size().

## ◆ gatherDefaultTypeArgs()

void ObjCTypeParamList::gatherDefaultTypeArgs | ( | SmallVectorImpl< QualType > & | typeArgs | ) | const

Gather the default set of type arguments to be substituted for these type parameters when dealing with an unspecialized type.

Definition at line 1470 of file DeclObjC.cpp.

## ◆ getLAngleLoc()

SourceLocation clang::ObjCTypeParamList::getLAngleLoc | ( |  | ) | const
| inline

Definition at line 712 of file DeclObjC.h.

References clang::SourceLocation::getFromRawEncoding().

Referenced by clang::Sema::ActOnStartCategoryInterface().

## ◆ getRAngleLoc()

SourceLocation clang::ObjCTypeParamList::getRAngleLoc | ( |  | ) | const
| inline

Definition at line 716 of file DeclObjC.h.

References clang::SourceLocation::getFromRawEncoding().

## ◆ getSourceRange()

SourceRange clang::ObjCTypeParamList::getSourceRange | ( |  | ) | const
| inline

Definition at line 720 of file DeclObjC.h.

Referenced by clang::Sema::ActOnForwardClassDeclaration(), and clang::Sema::ActOnStartCategoryInterface().

## ◆ size()

unsigned clang::ObjCTypeParamList::size | ( |  | ) | const
| inline

Determine the number of type parameters in this list.

Definition at line 689 of file DeclObjC.h.

Referenced by clang::ASTDeclWriter::AddObjCTypeParamList(), and clang::ObjCObjectType::computeSuperClassTypeSlow().

## Member Data Documentation

## ◆ AlignmentHack

ObjCTypeParamDecl* clang::ObjCTypeParamList::AlignmentHack

Definition at line 662 of file DeclObjC.h.

## ◆ Brackets

PODSourceRange clang::ObjCTypeParamList::Brackets

Location of the left and right angle brackets.

Definition at line 659 of file DeclObjC.h.

## ◆ TrailingObjects

friend clang::ObjCTypeParamList::TrailingObjects

Definition at line 673 of file DeclObjC.h.

The documentation for this class was generated from the following files:

- include/clang/AST/DeclObjC.h
- lib/AST/DeclObjC.cpp